'BBTodayAds.inc
' - this file holds the program constants, globals, and code for configuring the ads                                             

$ver = "1.76"

%IDC_MagazineTab  = 101                                                                              
%IDC_MonthCombo   = 102                                                                         
%IDC_MagMonth     = 103
%IDC_View         = 104
%IDC_Edit         = 105
%IDC_Listview1    = 106
%IDC_Scrollbar1   = 107             
%IDC_Textbox1     = 108
%IDC_Combobox1    = 109
%IDC_Combobox2    = 110
%IDC_Combobox3    = 111
%IDC_Pickup       = 112
%IDC_ShowPickup   = 113                                      
%IDC_ConfigBtn    = 114
%IDC_AdvanceBtn   = 115
%IDC_ReportBtn    = 116
%IDC_RunShtBtn    = 117
%IDC_HelpBtn1     = 118
%IDC_Statusbar1   = 121
%IDC_ContOpt      = 122
%IDC_ArcOpt       = 123
%IDC_LVreport     = 124
%IDC_salesPerson1 = 131
%IDC_salesPerson2 = 132
%IDC_PrnReport    = 133
%IDC_Begin        = 134                                                                                                          
%IDC_Close        = 135
%IDC_Report1      = 136
%IDC_Report2      = 137
%IDC_AdvList      = 151
%IDC_AdvCombo     = 152
%IDC_AdvAdd       = 153
%IDC_AdvEdt       = 154
%IDC_AdvDel       = 155
%IDC_AdvClr       = 156                
%IDC_Date         = 161
%IDC_Adv          = 162
%IDC_Paid         = 163
%IDC_SubmitBtn    = 164

%IDC_ConfigLabel  = 201
%IDC_Listview     = 202
%IDC_Scrollbar    = 203
%IDC_Textbox      = 204                   
%IDC_AddAd        = 205
%IDC_DelAd        = 206
%IDC_SalesCombo   = 207
%IDC_PctComm      = 208
%IDC_SizeCombo    = 209
%IDC_PubCombo     = 210
%IDC_ColorTxtbox  = 211
%IDC_BWTxtbox     = 212
%IDC_Statusbar    = 213
%IDC_HelpBtn      = 214                                                       
%ID_ComboAdd      = 221                                            
%ID_ComboDel      = 222             
                                       
global dBug as long                                   
global hMain, hDlg, hListview, hListview1, hColorTxtbox, hBWTxtbox, hPctComm, hReport, hAdv as long      
global hTextbox, hTextbox1, hCombobox1, hCombobox2, hCombobox3, hFont, gOrigTextbox, gOrigCombobox as long
global gOrigTextbox1, gOrigCombobox1, gOrigCombobox2, gOrigCombobox3, gOrigListview, gOrigListview1 as long    
global hMonthly, hSkiMag, hFont1, hFont2, hSummer, hOctFest, hPickup, lastTab, tabNo, monthNo, lastMonth as long
global editInWork, adsChanged, dataChanged, advDataChanged, showDropDown, savedMaxRows, gOrigPickup as long
global currentRow, currentCol, lastRow, lastCol, storedYr, viewOnly, ghKbdHook, archivedFile as long                          
global maxRows, topRow, numView, nView, choice2, choice4, choice8, endProg, scrolling, hScrollbar1 as long
global numSalesPeople, numAdSizes, numAdStatus, numSizes, numRows, currentDlg, pickup0 as long
global numAdvEntries, numAdvEntries1, numAdvEntries2 as long
global lastText, cellText, changedText as wstring                      
global ver, month, iniFile, dataFile, sold, pct, helpFile, pickupTxt as string
global salesPeople(), salesPeople1(), pctComm(), adSizes(), adStatus(), pickup(), mag(), ColAds(), BWAds() as string
global months(), dataStor() as string
global stor() as wstring                                                                   
global index(), idCtrl() as long
global arrDate(), arrDate1(), arrDate2() as string
global arrAdv(), arrAdv1(), arrAdv2() as double                    
global arrPaid(), arrPaid1(), arrPaid2() as double
global arrBal() as double
global si AS SCROLLINFO
                    

SUB configAds()         
   local nStyle, i as long
   local s, sTitle as string
   currentDlg = 2
   dialog font "Tahoma", 10                                                                                      
   sTitle = "Options for Big Bear Today Ad Sales"
   nStyle = %WS_CAPTION OR %WS_POPUP OR %DS_MODALFRAME OR %WS_SYSMENU OR %WS_MINIMIZEBOX  
   DIALOG NEW PIXELS, hMain, sTitle, , , 500, 520, nStyle TO hDlg
   control add label, hDlg, %IDC_ConfigLabel, "Configure Ad Sales", 10, 10, 200, 24
   nStyle = %LVS_Report or %LVS_NOSCROLL Or %WS_Visible or %LVS_SINGLESEL or %WS_tabstop
   CONTROL ADD LISTview, hDlg, %IDC_Listview, "", 10, 50, 435, 230, nStyle, %WS_Ex_ClientEdge
   Control Handle hDlg, %IDC_Listview To hListview
   gOrigListview = SetWindowLong(hListview, %GWL_WndProc, CodePtr(subclassListview)) 
   ListView Set StyleXX hDlg, %IDC_Listview, %LVS_Ex_GridLines Or %LVS_Ex_FullRowSelect
   LISTVIEW INSERT COLUMN hDlg, %IDC_Listview, 1, "Ads", 150, 0
   LISTVIEW INSERT COLUMN hDlg, %IDC_Listview, 2, "Monthly", 70, 2                                                  
   LISTVIEW INSERT COLUMN hDlg, %IDC_Listview, 3, "Ski Mag", 70, 2
   LISTVIEW INSERT COLUMN hDlg, %IDC_Listview, 4, "Summer ", 70, 2                 
   LISTVIEW INSERT COLUMN hDlg, %IDC_Listview, 5, "OctFest", 70, 2
   control add scrollbar, hDlg, %IDC_Scrollbar, "", 445, 50, 20, 230, %SBS_VERT or %WS_TABSTOP
   nView = Listview_GetCountPerPage(hListview)
   createTextbox
   control add button, hDlg, %IDC_AddAd, "&Add Ad", 20, 285, 80, 35
   control add button, hDlg, %IDC_DelAd, "&Del Ad", 105, 285, 80, 35
   'sales people                                                                     
   control add label, hDlg, -1, "Sales people:", 20, 350, 80, 15
   nStyle = %cbs_dropdown or %WS_tabstop or %cbs_sort or %WS_VSCROLL
   control add combobox, hDlg, %IDC_SalesCombo, salesPeople(), 105, 350, 150, 100, nStyle, %WS_EX_WINDOWEDGE
   'percent commission                                                                                                           
   control add label, hDlg, -1, "Pct comm:", 280, 350, 70, 15
   control add textbox, hDlg, %IDC_PctComm, "", 350, 350, 70, 20
   control handle hDlg, %IDC_PctComm to hPctComm
   'prices - ad size
   control add label, hDlg, -1, "Ad size:", 45, 410, 70, 15
   nStyle = %cbs_dropdownlist or %WS_tabstop or %WS_VSCROLL
   control add combobox, hDlg, %IDC_SizeCombo, adSizes(), 105, 410, 90, 160, nStyle, %WS_EX_WINDOWEDGE
   'prices - publication
   control add label, hDlg, -1, "Publication:", 225, 410, 70, 15
   control add combobox, hDlg, %IDC_PubCombo, Mag(), 295, 410, 90, 120, nStyle, %WS_EX_WINDOWEDGE
   'prices - color ads
   control add label, hDlg, -1, "Color price:", 35, 440, 70, 15
   control add textbox, hDlg, %IDC_ColorTxtbox, "", 105, 440, 90, 20
   control handle hDlg, %IDC_ColorTxtbox to hColorTxtbox
   'prices - black/white ads
   control add label, hDlg, -1, "B/W price:", 225, 440, 70, 15
   control add textbox, hDlg, %IDC_BWTxtbox, "", 295, 440, 90, 20
   control handle hDlg, %IDC_BWTxtbox to hBWTxtbox                                            
   'price frame, help, statusbar
   control add frame, hDlg, -1, "Prices", 20, 390, 390, 90
   control add button, hDlg, %IDC_HelpBtn, "?", 440, 410, 30, 35
   control add statusbar, hDlg, %IDC_Statusbar, "", 0, 0, 0, 0
   STATUSBAR SET PARTS hDlg, %IDC_Statusbar, 9999

   'Font --------------------------------------------------------------------------------
   control set font hDlg, %IDC_ConfigLabel, hFont1
   Control Set Font hDlg, %IDC_ListView, hFont          
   control set font hDlg, %IDC_SalesCombo, hFont                                                                     
   DIALOG SHOW MODAL hDlg CALL configAdsProc                          
END SUB                                                  

CALLBACK FUNCTION configAdsProc()
   local i, k, m, n, nItem, ans, nCombo, siMax as long
   local salesPerson as string
   local s as wstring
   Local LpLvNm As NM_LISTVIEW Ptr
   LOCAL comboInfo AS COMBOBOXINFO   
   STATIC hCombo, hComboEd, nSalesCombo, hScrollbar AS LONG
   static sPct, sColor, sBW as string
   SELECT CASE CB.MSG
      CASE %WM_INITDIALOG 
         iniFile = Exe.Name$ + ".ini"
         if maxRows then
            topRow = 1: currentRow = 1: currentCol = 1
            lastRow = currentRow: lastCol = currentCol
            numView = min(nView, maxRows)
            for i = 1 to numView
               LISTVIEW INSERT ITEM hDlg, %IDC_Listview, i, 0, "" 
            next i
            scrollView 
            gbGrid_GoToCurrentCell(1)
            showTxtCaret(1)
            'gbGrid_Caret(1)
         end if
         'subclass combobox for sales people to detect [ENTER] and [DEL]
         CONTROL HANDLE CB.HNDL, %IDC_SalesCombo TO hCombo
         comboInfo.cbsize = SIZEOF(COMBOBOXINFO)
         GetComboBoxInfo(hCombo, BYVAL VARPTR(comboInfo))
         hComboEd = comboInfo.hwndItem
         gOrigCombobox = SetWindowLong(hComboEd, %GWL_WndProc, CodePtr(SubclassCombobox))
         control handle cb.hndl, %IDC_Scrollbar to hScrollbar
         updateScrollInfo(hScrollbar)              
         control set focus hListview, %IDC_Textbox
      CASE %WM_VSCROLL
         if maxRows <= nView then exit function
         scrolling = 1
         m = topRow - currentRow                   
         si.nPos = topRow
         SELECT CASE LOWRD(cb.wparam)
            CASE %SB_LINEDOWN                                                                                           
               si.nPos = si.nPos + 1
            CASE %SB_PAGEDOWN
               si.nPos = si.nPos + si.nPage
            CASE %SB_LINEUP
               si.nPos = si.nPos - 1
            CASE %SB_PAGEUP                                                                                               
               si.nPos = si.nPos - si.nPage 
            CASE %SB_THUMBPOSITION, %SB_THUMBTRACK
               si.nPos = HIWRD(cb.wparam)
            CASE ELSE                                    
               EXIT FUNCTION
         END SELECT
         'ensure range is correct with following two statements 
         siMax = maxRows - numView + 1
         if si.nPos < 1 then si.nPos = 1: exit function
         if si.nPos > siMax then si.nPos = siMax: exit function
         si.cbSize = SIZEOF(si)
         si.fMask = %SIF_POS OR %SIF_PAGE
         SetScrollInfo BYVAL hScrollbar, BYVAL %SB_CTL, si, 1
         topRow = si.nPos
         currentRow = topRow - m
         'lastRow = currentRow 
         scrollView
         control set focus hListview, %IDC_Textbox
'         ListView Get Text hDlg, %IDC_Listview, currentRow-topRow+1, currentCol To s
'         Control Set Text hListview, %IDC_TextBox, s
      Case %WM_Notify
         Select Case Cb.NmId
            Case %IDC_ListView                         
               Select Case Cb.NmCode
                  Case %LVN_ColumnClick
                     'Dialog Post cb.hndl, %WM_User+500, 0, 0
                  Case %NM_Click, %NM_RClick
                     LpLvNm = Cb.LParam
                     currentRow = topRow + @LpLvNm.iITem
                     currentCol = @LpLvNm.iSubItem + 1
                     gbGrid_GoToCurrentCell(0)
                     'if currentCol = 1 then gbGrid_Caret(1) else gbGrid_Caret(0)
               End Select                                                            
         End Select                                                                  
      CASE %WM_COMMAND                                                               
         Select Case Cb.Ctl
            Case %IdOk  'typed ENTER in the floating textbox
               If currentCol = 1 and GetFocus = hTextbox then
                  Control Get Text hListview, %IDC_Textbox To s
                  if len(s) = 0 then exit function 'name cannot be nil
                  stor(1, currentRow) = s: changedText = s 
                  ListView Set Text hDlg, %IDC_Listview, currentRow-topRow+1, currentCol, changedText
                  if currentRow = maxRows then 
                     incr currentCol
                  else
                     currentRow = Min(maxRows, currentRow+1)    
                  end if
                  gbGrid_GoToCurrentCell(1)
                  adsChanged = 1
               else
                  if currentRow < maxRows then
                     if currentRow = topRow + numView - 1 then
                        dialog send hDlg, %WM_Vscroll, %SB_LINEdown, 0
                     else
                        incr currentRow
                     end if
                  else
                     decr currentRow 
                  end if
                  gbGrid_GoToCurrentCell(1)
               end if
               function = 1: exit function
            case %IDCancel
               Control Set Text hListview, %IDC_TextBox, lastText
               changedText = lastText: function = 1: exit function
            case %IDC_SalesCombo                                                
               select case cb.ctlmsg
                  case %cbn_setfocus
                     control set text cb.hndl, %IDC_SalesCombo, ""
                     control set text cb.hndl, %IDC_PctComm, ""
                  case %cbn_editchange                                            
                     combobox get select CB.HNDL, %IDC_SalesCombo to n
                     if n = 0 then control set text cb.hndl, %IDC_PctComm, ""
                  case %CBN_SELCHANGE
                     combobox get select CB.HNDL, %IDC_SalesCombo to n
                     if n and ubound(salesPeople) >= n then                        
                        control set text CB.HNDL, %IDC_SalesCombo, salesPeople(n)    
                        control set text cb.hndl, %IDC_PctComm, pctComm(n)
                     end if
               end select
               showStatus 3 
            case %IDC_PctComm 
               if cb.ctlmsg = %EN_setfocus then
                  control get text CB.HNDL, %IDC_SalesCombo to s
                  if len(s) then
                     COMBOBOX FIND EXACT cb.hndl, %IDC_SalesCombo, 1, s TO nSalesCombo
                     if nSalesCombo = 0 then control set focus cb.hndl, %IDC_SalesCombo
                  end if 
               elseif nSalesCombo and cb.ctlmsg = %EN_KILLFOCUS then
                  control get text cb.hndl, %IDC_PctComm to s
                  pctComm(nSalesCombo) = s
                  adsChanged = 1
               end if
               showStatus 4                       
            case %IDC_ColorTxtbox
               showStatus 5
               if cb.ctlmsg = %EN_KILLFOCUS then
                  control get text cb.hndl, %IDC_ColorTxtbox to sColor
                  combobox get select cb.hndl, %IDC_PubCombo to m
                  combobox get select cb.hndl, %IDC_SizeCombo to n      
                  colAds(numAdSizes * (m-1) + n) = sColor
                  adsChanged = 1
               end if                                                                                               
            case %IDC_BWTxtbox
               showStatus 5
               if cb.ctlmsg = %EN_KILLFOCUS then
                  control get text cb.hndl, %IDC_BWTxtbox to sBW
                  combobox get select cb.hndl, %IDC_PubCombo to m
                  combobox get select cb.hndl, %IDC_SizeCombo to n
                  BWAds(numAdSizes * (m-1) + n) = sBW
                  adsChanged = 1
               end if
            case %IDC_AddAd
               addAd()                    
            case %IDC_DelAd                   
               delAd()
            case %IDCANCEL 'ESC brings us here
               if currentCol = 1 then 'restore edited ad
                  s = stor(1, currentRow) 
                  ListView Set Text cb.hndl, %IDC_Listview, currentRow-topRow+1, 1, s
                  gbGrid_GoToCurrentCell(1)
               end if                                  
            CASE %ID_ComboAdd 'add sales person
               IF GetFocus = hComboEd THEN  'On the combobox edit part
                  CONTROL GET TEXT CB.HNDL, %IDC_SalesCombo TO salesPerson
                  IF LEN(salesPerson) = 0 THEN EXIT FUNCTION
                  COMBOBOX FIND EXACT CB.HNDL, %IDC_SalesCombo, 1, salesPerson TO nItem
                  IF nItem = 0 THEN 'new sales person
                     if numSalesPeople = 2 then
                        s = "Number of sales people is limited to 2"               
                        msgbox s, %MB_iconerror, "BBTodayAds - ver " + $ver
                        CONTROL sET TEXT CB.HNDL, %IDC_SalesCombo, ""
                        exit function
                     end if   
                     COMBOBOX ADD CB.HNDL, %IDC_SalesCombo, salesPerson
                     incr numSalesPeople
                     redim preserve salesPeople(1 to numSalesPeople)        
                     redim preserve pctComm(1 to numSalesPeople)
                     combobox find exact CB.HNDL, %IDC_SalesCombo, 1, salesPerson to n
                     array insert salesPeople(n), salesPerson
                     array insert pctComm(n), ""
                     control set focus cb.hndl, %IDC_PctComm
                     control set text cb.hndl, %IDC_PctComm, ""
                     showStatus 0: adsChanged = 1                         
                  end if                                                                        
               END IF
            CASE %ID_ComboDel 'delete sales person
               IF GetFocus = hComboEd THEN  'On the combo edit part
                  CONTROL GET TEXT CB.HNDL, %IDC_SalesCombo TO salesPerson
                  for n = 1 to 15
                        for i = 1 to maxRows
                           if dataStor(n, 2, i) = salesPerson then 
                              s = "Cannot delete" + $CRLF + $CRLF _
                                + "Ad data has already been assigned to this person" + $crlf + $crlf _
                                + "... either remove that data first or wait untill next year"  + $crlf _
                                + "(best to wait because archiving the file clears all data)"
                              MSGBOX s, %MB_ICONerror, salesPerson
                              exit function 
                           end if
                        next i                                              
                  next n      
                  COMBOBOX FIND EXACT CB.HNDL, %IDC_SalesCombo, 1, salesPerson TO nCombo
                  IF nCombo THEN                                                              
                     COMBOBOX GET TEXT CB.HNDL, %IDC_SalesCombo, nCombo TO salesPerson
                     CONTROL SET TEXT CB.HNDL, %IDC_SalesCombo, salesPerson
                     s = "Delete this sales person?"
                     ans = MSGBOX(s, %MB_YESNO or %MB_ICONQUESTION, salesPerson)
                     IF ans = %IDYES THEN
                        COMBOBOX DELETE CB.HNDL, %IDC_SalesCombo, nCombo
                        CONTROL SET TEXT CB.HNDL, %IDC_SalesCombo, ""
                        array delete salesPeople(nCombo)
                        array delete pctComm(nCombo)
                        decr numSalesPeople: adsChanged = 1
                        control set text cb.hndl, %IDC_PctComm, ""               
                     END IF                                 
                  END IF
               END IF          
            case %IDC_SizeCombo, %IDC_PubCombo
               combobox get select cb.hndl, %IDC_PubCombo to m
               combobox get select cb.hndl, %IDC_SizeCombo to n
               if m > 0 and n > 0 then
                  k = (m-1)*numAdSizes + n
                  control set text cb.hndl, %IDC_ColorTxtbox, colAds(k)
                  control set text cb.hndl, %IDC_BWTxtbox, BWAds(k)                      
               end if
            case %IDC_HelpBtn                                                      
               if isfile(helpFile) then                   
                  appHelp helpFile, "", hMain                         
               else                                                                          
                  MSGBOX "Help file not found", %MB_ICONERROR, helpFile 
               end if                       
               Control Set Focus hListview1, %IDC_TextBox                                                           
         END SELECT
         if currentCol > 1 and cb.ctl <> %IDC_Listview then
            'all this just to center the checkmark when out of listView      
            n = GetFocus()                                  
            currentCol = 1: gbGrid_GoToCurrentCell(0)
            SetFocus n
         end if                                       
      CASE %WM_SYSCOMMAND
         IF CBCTL = %SC_CLOSE THEN
            combobox get count CB.HNDL, %IDC_SalesCombo to numSalesPeople
         end if
   END SELECT
END FUNCTION 

function subclassListview(BYVAL hWnd as long, BYVAL Msg as long, BYVAL wParm as long, BYVAL lParm as long) AS LONG
   'for scrolling the mouse with the mouse wheel over the listview control 
   local n as long
   local s as Wstring                        
   SELECT CASE Msg                                                 
      Case %WM_MouseWheel
         Select Case Hi(Integer,WParm) '...note the use of Integer
            Case > 0  'wheel up                                                    
               if topRow > 1 and currentRow > 1 then                         
                  dialog send hDlg, %WM_Vscroll, %SB_LINEup, 0
               end if                                                                           
            Case < 0  'wheel down
               If (topRow < maxRows - numView + 1) and currentRow < numRows Then    
                  dialog send hDlg, %WM_Vscroll, %SB_LINEDOWN, 0
               end if
         End Select
   end select
   Function = CallWindowProc(gOrigListview, hWnd, Msg, wParm, lParm)
end function
                                                     
FUNCTION subclassTextbox(BYVAL hWnd as long, BYVAL Msg as long, BYVAL wParm as long, BYVAL lParm as long) AS LONG
   local n as long
   local s as Wstring                                                                      
   Select Case Msg
      case %WM_CHAR
         if currentCol > 1 then
            'if wParm = 32 or wParm = 43 then 'spacebar or "+" key
            if wParm = %VK_SPACE then
               toggleAddmark 
               ListView Get Text hDlg, %IDC_Listview, currentRow-topRow+1, currentCol To s
               Control Set Text hListview, %IDC_TextBox, s
            end if
            DestroyCaret: function = 1: exit function                   
         end if
      Case %WM_KeyDown                                             
         Select Case wParm                                                      
            case %VK_Up                                                                     
               if currentRow = topRow then 
                  dialog send hDlg, %WM_Vscroll, %SB_LINEup, 0
               elseif currentRow > 1 then 
                  decr currentRow
               end if
               gbGrid_GoToCurrentCell(1)
            Case %VK_Down                                                           
               if currentRow = topRow + numView - 1 then 
                  dialog send hDlg, %WM_Vscroll, %SB_LINEdown, 0
               elseIf CurrentRow < maxRows Then
                  incr currentRow
               end if
               gbGrid_GoToCurrentCell(1)
            Case %VK_Left                                                  
               if editInWork = 0 or (GetKeyState(%VK_SHIFT) AND &H8000) then
                  CurrentCol = Max(1,CurrentCol-1): gbGrid_GoToCurrentCell(0)
               end if
            Case %VK_Right
               if editInWork = 0 or (GetKeyState(%VK_SHIFT) AND &H8000) then
                  CurrentCol = min(5,CurrentCol+1): gbGrid_GoToCurrentCell(0)
               end if
            Case %VK_Pgup
               currentRow = Max(1, currentRow-numView): gbGrid_GoToCurrentCell(1)
            Case %VK_PgDn
               currentRow = Min(maxRows, currentRow+numView): gbGrid_GoToCurrentCell(1)
            Case %VK_Home
               currentRow = 1: gbGrid_GoToCurrentCell(1)
            Case %VK_End 
               currentRow = maxRows: gbGrid_GoToCurrentCell(1)
            Case %VK_Control, %VK_Shift
         End Select
         'if currentCol = 1 then gbGrid_Caret(1) else gbGrid_Caret(0)
         if currentCol = 1 then editInWork = 1 else editInWork = 0
         if currentCol = 1 then showTxtCaret(1) else showTxtCaret(0)
         'following statement to eliminate unwanted selection
         if currentCol = 1 and (wParm = %VK_Down or wParm = %VK_End) then exit function
   End Select
   Function = CallWindowProc(gOrigTextbox, hWnd, Msg, wParm, lParm)
end function

FUNCTION subclassCombobox(BYVAL hWnd as long, BYVAL Msg as long, BYVAL wParm as long, BYVAL lParm as long) AS LONG
   local ans, nItem as long
   Select Case Msg
      Case %WM_KeyUP                                      
         if wParm = %VK_Return then
            DIALOG SEND hDlg, %WM_COMMAND, %ID_ComboAdd, 0
            function = 1: exit function
         end if
      Case %WM_Keydown                                          
         if wParm = %VK_Delete then
            DIALOG SEND hDlg, %WM_COMMAND, %ID_ComboDel, 0
            function = 1: exit function
         end if   
   end select
   Function = CallWindowProc(gOrigCombobox, hWnd, Msg, wParm, lParm)
end function

Sub gbGrid_GoToCurrentCell(EnSureVisible As Long)
   'move textbox selector to next item
   local wText as wstring
   Local rc As Rect
   if maxRows = 0 then exit sub 
   if currentRow <> lastRow or currentCol <> lastCol then 'update last cell
      ListView set Text hDlg, %IDC_Listview, lastRow-topRow+1, lastCol, changedText
      stor(lastCol, lastRow) = changedText
   end if
   if currentRow > topRow + numView - 1 then
      topRow = max(currentRow - numView + 1, 1)
      topRow = min(topRow, maxRows - numView + 1)                    
      if EnsureVisible then scrollView
   elseif currentRow < topRow then
      topRow = currentRow
      if EnsureVisible then scrollView
   end if
   showStatus iif(currentCol = 1, 1, 2)
   if lastCol = 0 or (lastCol > 1 and currentCol = 1) or (lastCol = 1 and currentCol > 1) then createTextbox
   'set the text before moving to avoid a visual flicker
   'move/resize TextBox over ListView cell
   ListView_GetSubItemRect hListview, currentRow-topRow,currentCol-1, %LVIR_Label, varptr(rc)       
   Control Set Size hListview, %IDC_TextBox, rc.nRight-rc.nLeft, rc.nBottom-rc.nTop
   Control Set Loc hListview, %IDC_TextBox, rc.nLeft, rc.nTop                                    
   ListView Get Text hDlg, %IDC_Listview, currentRow-topRow+1, currentCol To wText
   Control Set Text hListview, %IDC_TextBox, wText: lastText = wText: changedText = wText
   if currentCol = 1 then editInWork = 1 else editInWork = 0
   'debug currentCol
   if currentCol = 1 then showTxtCaret(1&) else showTxtCaret(0) 
   lastRow = currentRow: lastCol = currentCol 
End Sub

sub CreateTextbox()
   'create textbox for selecting items in Listview                               
   local nStyle, carotPosn as long
   if hTextbox then control kill hListview, %IDC_Textbox
   nStyle = %WS_TabStop Or %WS_Border Or %ES_Left
   control add textbox, hListview, %IDC_Textbox, "", 0, 0, 0, 0, nStyle, %WS_Ex_Windowedge
   Control Handle hListview, %IDC_TextBox To hTextBox
   Control Set Font hListView, %IDC_TextBox, hFont
   gOrigTextbox = SetWindowLong(hTextBox, %GWL_WndProc, CodePtr(SubclassTextbox))
end sub
                                                    
sub showTxtCaret(n as long)
   setFocus hListview
   setFocus hTextbox
   showCaret(hTextbox)
   if n = 0 then hideCaret(hTextbox)
end sub

sub toggleAddmark
   'toggle checkmark for items in columns other than the first of Listview
   local temp, c as Wstring
   'c = chr$(43)
   c = chr$$(10003)
   listview get text hDlg, %IDC_ListView, currentRow-topRow+1, currentCol to temp
   if temp = c then temp = "" else temp = c
   ListView Set Text hDlg, %IDC_ListView, currentRow-topRow+1, currentCol, temp
   'stor(currentCol, currentRow) = temp
   changedText = temp
   adsChanged = 1
end sub

sub scrollView()
   'used when scrolling is required
   local i, j, n as long
   n = min(maxRows, nView)                                             
   for j = 1 to 5
   for i = 1 to n                                                        
      listView set text hDlg, %IDC_Listview, i, j, stor(j, topRow + i - 1)
   next i                                                                    
   next j
end sub

sub updateScrollInfo(hScrollbar as long)
   local n as long
   si.cbSize = LEN(si)
   si.fMask  = %SIF_ALL                                                             
   si.nMin   = 1
   si.nMax   = max(1, maxRows + 1 - numView)
   si.nPage  = max(1, (si.nMax - si.nMin) \ 6)
   si.nPos   = 1
   SetScrollInfo BYVAL hScrollbar, BYVAL %SB_CTL, si, 1
end sub                                                             

sub addAd()
   local i as long                                          
   incr maxRows
   redim preserve stor(1 to 5, 1 to maxRows)
   currentRow = maxRows: currentCol = 1
   numView = min(nView, maxRows)
   topRow = maxRows - nView + 1
   LISTVIEW INSERT ITEM hDlg, %IDC_Listview, maxRows, 0, stor(1, maxRows)
   scrollView: gbGrid_GoToCurrentCell(1)
   'gbGrid_Caret(1)
   adsChanged = 1
end sub                                                                                         

sub delAd()
   local i, j, k, n, nItem, ans as long
   local s as string, ad as string
   nItem = currentRow - topRow + 1                                    
   LISTVIEW GET TEXT hDlg, %idc_Listview, nItem, 1 TO ad
   'first, check if there is any data with this ad                      
   if currentRow <= savedMaxRows then               
      for n = 1 to 15                                        
         for j = 2 to 8                                                     
            if len(dataStor(n, j, currentRow)) then incr k: exit: exit        
         next j
      next n
      if k then
         s = "Cannot delete" + $CRLF + $CRLF _
           + "This ad contains data already input by the user" + $crlf + $crlf _
           + "... either remove that data first or wait untill next year"  + $crlf _
           + "(best to wait because archiving the file clears all data)"
         MSGBOX s, %MB_ICONerror, ad
         exit sub
      end if 
   end if
   ans = msgbox("Delete this Ad now?", %MB_YESNO, ad)      
   if ans = %IDNo then exit sub
   decr maxRows   
   for j = 1 to 5 'delete selected row from stor()
      for i = currentRow to maxRows 
            stor(j, i) = stor(j, i+1)
      next i
   next j
   redim preserve stor(1 to 5, 1 to maxRows)
   if currentRow <= savedMaxRows then                      
      for n = 1 to 15 'delete selected row from dataStor()
         for j = 1 to 8
            for i = currentRow to maxRows
               dataStor(n, j, i) = dataStor(n, j, i+1)
            next i 
         next j
      next n
      redim preserve dataStor(1 to 15, 1 to 8, 1 to maxRows) 
   end if   
   if (topRow + nView >= maxRows) and topRow > 1 then decr topRow
   numView = min(nView, maxRows)
   if currentRow > maxRows then decr currentRow
   redim preserve stor(1 to 5, 1 to maxRows) 
   scrollView
   gbGrid_GoToCurrentCell(0)
   adsChanged = 1
end sub
                                                            
Sub loadIniFile()
   local i, j, fileNo as long                
   local s, sVer as Wstring
   local c as wstring
   'c = chr$(43)
   c = chr$$(10003)
   fileNo = FREEFILE                             
   OPEN iniFile FOR inPUT AS fileNo                            
   input #fileNo, sVer
   input #fileNo, maxRows, numSalesPeople
   if maxRows = 0 then close #fileNo: exit sub                        
   redim stor(1 to 5, 1 to maxRows) as Wstring                      
   for i = 1 to maxRows
      input #fileNo, stor(1, i), stor(2, i), stor(3, i), stor(4, i), stor(5, i)
   next i
   combobox reset hDlg, %IDC_SalesCombo
   if numSalesPeople then                                    
      redim salesPeople(1 to numSalesPeople) as string
      redim pctComm(1 to numSalesPeople) as string
      for i = 1 to numSalesPeople
         input #fileNo, salesPeople(i), pctComm(i)
      next i
   end if                                                                  
   for i = 1 to numSizes
      input #fileNo, colAds(i), BWAds(i)
   next i
   close #fileNo                               
   for j = 2 to 5
      for i = 1 to maxRows
         if len(stor(j, i)) then stor(j, i) = c
      next i
   next j                                               
end sub

Sub saveIniFile()
   local i, fileNo as long
   local s as Wstring
   if isfile(iniFile) then kill iniFile
   fileNo = FREEFILE
   OPEN iniFile FOR OUTPUT AS fileNo
   write #fileNo, $ver
   write #fileNo, maxRows, numSalesPeople
   for i = 1 to maxRows
      write #fileNo, stor(1, i), stor(2, i), stor(3, i), stor(4, i), stor(5, i)
   next i
   for i = 1 to numSalesPeople  
      write #fileNo, salesPeople(i), pctComm(i)
   next i
   for i = 1 to numSizes                                         
      write #fileNo, colAds(i), BWAds(i)
   next i
   adsChanged = 0
   CLOSE #fileNo
end sub   

SUB showStatus(nMsg as long)
   local msg as string 
   select case nMsg
      case 1: msg = "name or description of ad, [ENTER] to save, [ESC] to restore"
      case 2: msg = "[SPACE] to toggle checkmark on/off"
      case 3: msg = "up/down keys or click pulldown list to select, [ENTER] to save"
      case 4: msg = "percent of sales for sales person, [ENTER] or move to save"
      case 5: msg = "price for Ad size/Publication combination, [ENTER] or move to save"      
   end select
   STATUSBAR SET TEXT hDlg, %IDC_Statusbar, 1, 0, msg
END SUB

